// Arduino IDE select `Tools`->`Board:`->ESP32 -> ESP32 Dev Module

/*
  Brett Oliver

  http://www.brettoliver.org.uk

  RTClib error ESP32
  //1.14.2 error
  //1.14.1 error
  //1.14.0 error
  // 1.13.0 working
  //  Copyright 2018 Brett Oliver
  //
  //  This program is free software: you can redistribute it and/or modify
  //  it under the terms of the GNU General Public License as published by
  //  the Free Software Foundation, either version 3 of the License, or
  //  (at your option) any later version.
  //
  //  This program is distributed in the hope that it will be useful,
  //  but WITHOUT ANY WARRANTY; without even the implied warranty of
  //  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  //  GNU General Public License for more details.
  //
  //  You should have received a copy of the GNU General Public License
  //  along with this program. If not, see http://www.gnu.org/licenses/
  // based on original project here https://create.arduino.cc/projecthub/user0035382/clock-with-alarm-hygrometer-thermometer-531acb
  //
  ################  Added version number line 572 ###############
  Taken from Brett Oliver's Time Teaching Clock, Work Clock3D /Analogue Clock
  Converted to Tombola Clock
  v2 MAX2719 removed
  v3 add tombola motor pins etc
  v4 detect hours1 and hours2 change mins to mins 2
  v5  add PCF8574 failed I2C clash

  v6 errors
  v7/v8 modified for ESP32WROOM32D
  v9 modified rotation values and corrected pins values on steppers 2,3 and 4
  v12 change start so rotors donot turn on initial power up
  v15 added PIR timeout on 10mins and prints out stored time digits for use later.
  v16 removing not needed code
  v17 cont. above
  v18 add analog read pins
  v19 acceleration experiment only
  v20 as v18
  v21 Add values for digit settings via 2 pots
  v22 RTC setting and added extra position to Select Pot for "Normal mode"
  v23 added time setting for stepper numerrals
  v25 time setting for stepper modules finished
  v26 when Numeral select off (value 9) and Set RTC button is pressed seconds are set to 0
  v27 remove redundant code
  v29 PIR removed
  v30 Sum Winter adjusted- Winter need to time changes to add extra mins when retard completed. - Sumer need to add display corrections
  v31 adding above
  v32 added led to GPIO1  cancelled not worth it-add mins missed when changing summer and wintertime
  v33 removed serialprint
  v34 moved RTC  reset to 0 to fast loop and add serial enable on boot by holding Set Disp button
  v35 changed stepping of Mins 10 and hours tens to match mins 1s and hours 1s
  v36 change rotation amounts
  v37 move rotations to voids
  v38 blank digiys added to Mins10 and Hrs10 so rotation added
  v39 adjust start rotation position not done yet may not be required
  v40 removed commented out code
*/





//###################################################################################################




#include <Wire.h>
#include <SPI.h>

#include "RTClib.h"
//#include "WiFi.h"




int secondNow = 0;
int secondPrevious = 0;
int secondNow1 = 0;
int secondPrevious1 = 0;
int summertime = 0;
int wintertime = 0;
int RTCset = 0;// RTC set input
int RTCsetValue = 1; // RTC set input value 0 pressed
int DispSet = 2; // Disp set input
int DispSetValue = 1; //Disp set input value 0 pressed
int SerialEnable = 0; // If Set Disp held at boot Serail is enabled and becomes 1

int hoursUnits = 0;// value set by pot Hrs1
int hoursTens = 0; // value set by pot Hrs10
int hoursRTC = 0; // set RTC hours y this number
int minsUnits = 0;// value set by pot Min1
int minsTens = 0; // value set by pot Min10
int minsRTC = 0;  //set RTC mins y this number

int midnight = 0; // sets number of rotatins of hrs 1 at midnight


//int extraLength = 500; //Length of extra pulse
//int pulseLength = 400; // sets lenth of pulse by adjusting  delay max 400 min 50

int midnightcheck = 0; //stops hours1 rotating continously.



/* Example sketch to control a 28BYJ-48 stepper motor with ULN2003 driver board, AccelStepper
  Turns 3/5 revolution backwards then step 1/5 forward and repeats.

*/

// Include the AccelStepper library:
#include <AccelStepper.h>

// Motor pin definitions:
//Mins Units
#define motorMin1Pin1  15      // IN1 on the ULN2003 driver
#define motorMin1Pin2  16      // IN2 on the ULN2003 driver
#define motorMin1Pin3  17     // IN3 on the ULN2003 driver
#define motorMin1Pin4  18     // IN4 on the ULN2003 driver

//Mins tens
#define motorMin2Pin1  19      // IN1 on the ULN2003 driver
#define motorMin2Pin2  33      // IN2 on the ULN2003 driver
#define motorMin2Pin3  12     // IN3 on the ULN2003 driver
#define motorMin2Pin4  32     // IN4 on the ULN2003 driver

//Hour Units
#define motorHours1Pin1  23      // IN1 on the ULN2003 driver
#define motorHours1Pin2  4       // IN2 on the ULN2003 driver
#define motorHours1Pin3  25     // IN3 on the ULN2003 driver
#define motorHours1Pin4  26     // IN4 on the ULN2003 driver

//Hour Tens
#define motorHours2Pin1  27      // IN1 on the ULN2003 driver
#define motorHours2Pin2  13      // IN2 on the ULN2003 driver
#define motorHours2Pin3  14     // IN3 on the ULN2003 driver
#define motorHours2Pin4  5     // IN4 on the ULN2003 driver


// Define the AccelStepper interface type; 4 wire motor in half step mode:
#define MotorInterfaceType 8

// Initialize with pin sequence IN1-IN3-IN2-IN4 for using the AccelStepper library with 28BYJ-48 stepper motor:
//Mins Units
AccelStepper stepperMinsUnits = AccelStepper(MotorInterfaceType, motorMin1Pin1, motorMin1Pin3, motorMin1Pin2, motorMin1Pin4);

//Mins tens
AccelStepper stepperMinsTens = AccelStepper(MotorInterfaceType, motorMin2Pin1, motorMin2Pin3, motorMin2Pin2, motorMin2Pin4);

//Hour Units
AccelStepper stepperHoursUnits = AccelStepper(MotorInterfaceType, motorHours1Pin1, motorHours1Pin3, motorHours1Pin2, motorHours1Pin4);


//Hour Tens
AccelStepper stepperHoursTens = AccelStepper(MotorInterfaceType, motorHours2Pin1, motorHours2Pin3, motorHours2Pin2, motorHours2Pin4);





RTC_DS3231 rtc;




#define syncPulse 36  // 30 second sync pin




//int hh1, mm1, zz1, dd1, mth1, yy1;
//int maxday;
boolean initial = 1;
boolean initialminutes1 = 1;
boolean initialminutes2 = 1;
boolean initialhours1 = 1;
boolean initialhours2 = 1;





//Brett
int LED = 1;
int secondsNow = 0;
int secondsOld = 0;
int minutePrevious = 0;
int minutes1Previous = 0;
int minutes2Previous = 0;
int hours1Previous = 0;
int hours2Previous = 0;
int BlankRotateMin10 = 0;
int BlankRotateHrs10 = 0;
int BlankRotateSum = 0;

//Time Digits stored for when PIR is activated again
//int PIRmin1 = 0;
//int PIRmin2 = 0;
//int PIRhour1 = 0;
//int PIRhour2 = 0;

// adj values on restart from PIR or power up
//int PIRmin1adj = 0;
//int PIRmin2adj = 0;
//int PIRhour1adj = 0;
//int PIRhour2adj = 0;


int minuteNow = 0 ;
//int AdvRtdPin = 3; //Pin for sensing advance/retard setting
//int AdvRtdVal = 0; // Analogue value 0-4095

int NumeralSelectPin = 34; //Pin for sensing digit for digital time setting //now numeral pin to be changed!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
int NumeralSelect = 0; // Analogue value 0-4095 //now numeral value to be changed!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
int NumeralSelected = 0; //Value of numeral selected for setting
int motorRotations = 0;
int winterRotations = 0;

int DigitSetPin = 39; //Pin for sensing digit for digital time setting
int DigitSet = 0; // Analogue value 0-4095
int DigitSetValue = 0; //Value of digit for digital clock setting




int AdvSet = 0; // Advance  pulses
int RtdSet = 0; //Retard pulses
int previousAdvRtdSet = 0;

int adjCount = 0; // set to number of pulses from rotary switch value AdvRtdSet
int previousadjCount = 0;


int h = 0;
int m = 0;
int s = 0;
int dd = 0;
int yy = 0;
int mth = 0;
int hours2 = 0; //2nd 7 segment hour digit
int hours1 = 0; //1st 7 segment hour digit
//int hours = 0;
int minutes2 = 0; //2nd 7 segment minute digit
int minutes1 = 0; //1st 7 segment minute digit
//int minutes = 0;
int seconds2 = 0;  //2nd 7 segment seconds digit
int seconds1 = 0; //1st 7 segment seconds digit

const byte PIRPin        = 35;// PIR sensor input pin
int PIROn                = 0;
long PIRtimer             = 0; //used for checking PIR timings
int PIRtimeout            = 600; //PIR time on after trigger in seconds

boolean coilStatus    = false;  // clock coil status
boolean retard        = false;  // true if clock going back
boolean advance       = true;  // false when AdvRtdSetUse is in use for counting advance/retard pulse values
boolean advanceLock   = false; // true hold on advance
boolean clockRun      = true;   // when false clock motor will stop used for retard and sync
boolean AdvRtdSetUse  = true;  // true if clock going back
boolean nosync        = true; // true allows 30 sec sync to go ahead only if clock is not advancing/retarding
boolean allowsync     = true; // true allows 30 sec re-sync after seconds get to 10 to stop multiple syncs when sync pulse received
boolean sumwin        = false; // true when setting sum win time


//const int clockCoil01 = 9;  // was A2 clock coil
//const int clockCoil02 = 13;  // was A3 clock coil
const int retardSw = 37;
const int advanceSw = 38;



//Brett



void setup ()
{

  //Serial.begin(9600);
  Wire.begin();


  pinMode(LED, OUTPUT);
  pinMode(PIRPin, INPUT);
  pinMode(syncPulse, INPUT);
  pinMode(RTCset, INPUT);
  pinMode(DispSet, INPUT);


  pinMode(NumeralSelectPin, INPUT);// digit select
  pinMode(DigitSetPin, INPUT);// digit select




  pinMode (motorMin1Pin1, OUTPUT);
  pinMode (motorMin1Pin2, OUTPUT);
  pinMode (motorMin1Pin3, OUTPUT);
  pinMode (motorMin1Pin4, OUTPUT);

  pinMode (motorMin2Pin1, OUTPUT);
  pinMode (motorMin2Pin2, OUTPUT);
  pinMode (motorMin2Pin3, OUTPUT);
  pinMode (motorMin2Pin4, OUTPUT);

  pinMode (motorHours1Pin1, OUTPUT);
  pinMode (motorHours1Pin2, OUTPUT);
  pinMode (motorHours1Pin3, OUTPUT);
  pinMode (motorHours1Pin4, OUTPUT);


  pinMode (motorHours2Pin1, OUTPUT);
  pinMode (motorHours2Pin2, OUTPUT);
  pinMode (motorHours2Pin3, OUTPUT);
  pinMode (motorHours2Pin4, OUTPUT);






  // Set the maximum steps per second:
  stepperMinsUnits.setMaxSpeed(1000);
  stepperMinsTens.setMaxSpeed(1000);
  stepperHoursUnits.setMaxSpeed(1000);
  stepperHoursTens.setMaxSpeed(1000);







  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  //rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));//set time from PC -don't use
  //rtc.adjust(DateTime(2022, 05, 26, 6, 43, 00)); //manual adjustment
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



  //Enable serial on boot by holding Set Disp button
  DispSetValue = digitalRead(DispSet);

  if ( DispSetValue == 0 )
  {
    SerialEnable = 1;
    Serial.begin(9600);
  }



}


void loop () //#####################################################################
{







  // 30 second sync to master clock pulse
  //if (digitalRead(syncPulse) == HIGH  && !advance && !retard && nosync == true && allowsync )// sync on 30seconds as long as clock not advancing or retarding
  if (digitalRead(syncPulse) == HIGH && allowsync )
  {

    //Serial.println("syncpulse ");

    allowsync = false ;
    rtc.adjust(DateTime(rtc.now().year(), rtc.now().month(), rtc.now().day(), rtc.now().hour(), rtc.now().minute(), 30));


  }

  if (rtc.now().second() == 10  )// allows seconds to sync again after seconds reach 10
  {
    allowsync = true ;
    //Serial.println("10 Seconds ");

  }

  // end 30 second sync to master clock pulse



  //Reset seconds to zero Numeral Select Switch fully anticlockwise and Set RTC pressed
  RTCsetValue = digitalRead(RTCset);
  if ( NumeralSelected == 9 && RTCsetValue == 0  )
  {
    // Serial.println("Seonds Reset");

    rtc.adjust(DateTime(rtc.now().year(), rtc.now().month(), rtc.now().day(), rtc.now().hour(), rtc.now().minute(), 0));
  }











  //Check every 10 seconds
  if ( get_sec() == 11 || get_sec() == 21 || get_sec() == 31 || get_sec() == 41 || get_sec() == 51 || get_sec() == 1 )
  {

  }






  //####################################################

  //Brett
  //Check every second

  secondNow = get_sec();
  // Serial.print("Second ");
  //Serial.print(ss);
  if (secondNow != secondPrevious || initial)
  {
    initial = 0;

    secondPrevious = secondNow;


    //flash LED every second to warn Selct pot not on clock run position
    //if ( rtc.now().second() % 2 == 0 && NumeralSelected != 9)
    //{
    //  digitalWrite (LED, HIGH);
    // Serial.println("LED ON ");

    //}

    //else
    //{
    //  digitalWrite (LED, LOW);
    //   //Serial.println("LED OFF ");
    //}
    // Turn on LED to warn Selct pot not on clock run position
    if ( NumeralSelected != 9)
    {
      digitalWrite (LED, HIGH);
    }

    else
    {
      digitalWrite (LED, LOW);
    }

    //LED shows 30 second marker
    if ( rtc.now().second() == 30 )
    {
      digitalWrite (LED, HIGH);

    }

    if ( rtc.now().second() == 31 )
    {
      digitalWrite (LED, LOW);

    }



    // converts seconds/minutes/hours to 2 single digits for 7 segment seconds display

    seconds2 = floor(get_sec() / 10); //gets 2nd seconds char from seconds for 7 segment display
    seconds1 = get_sec() - (seconds2 * 10); //gets 1st seconds char from seconds for 7 segment display

    minutes2 = floor(get_min() / 10); //gets 2nd seconds char from seconds for 7 segment display
    minutes1 = get_min() - (minutes2 * 10); //gets 1st seconds char from seconds for 7 segment display

    hours2 = floor(get_hour() / 10); //gets 2nd seconds char from hours for 7 segment display
    hours1 = get_hour() - (hours2 * 10); //gets 1st seconds char from hours for 7 segment display

    if (SerialEnable == 1)
    {
      Serial.print("Time ");
      Serial.print(hours2);
      Serial.print(hours1);
      Serial.print(":");
      Serial.print(minutes2);
      Serial.print(minutes1);
      Serial.print(":");
      Serial.print(seconds2);
      Serial.println(seconds1);
    }







    //####################################################################################################################################################################
    // Set digital time- set pot to digit and press relevant button to set that digit- hour1= hour tens, hour2= hour units,minute1= minute tens & minute2= minute units

    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    //the following 6 lines ae used for setting up the potentiometers. Comment out after setup completed
    NumeralSelectFunction();// gets the int value NumeralSelect from VR2
    DigitSetFunction();// Get digit value from pot
    //NumeralSelect = analogRead(NumeralSelectPin);    // read the value from the pot 0 to 4095
    Serial.print ("NumeralSelectPin Value ");
    Serial.print (NumeralSelect);

    Serial.print (" NumeralSelected ");
    Serial.println (NumeralSelected);

    DigitSet = analogRead(DigitSetPin);    // read the value from the pot 0 to 4095
    Serial.print ("DigitSet Value ");
    Serial.print (DigitSet);

    Serial.print (" DigitSetValue ");
    Serial.println (DigitSetValue);


    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~









    //set hours tens digit
    // Min1 =0   Min10 =1   Hrs1 =2   Hrs10 =3   Sum =4  Win =5
    if ( NumeralSelected == 3 && RTCsetValue == 0  )
    {
      // DigitalClockSettings();// gets the int value DigitalClockDigit from VR2

      if ( DigitSetValue < 3) //if greater than 2 not valind for hours tens digit
      {
        hoursTens = DigitSetValue;
        digitalWrite (LED, LOW);
        if (SerialEnable == 1)
        {
          Serial.print("hoursTens ");
          Serial.println(hoursTens);
        }
        // rtc.adjust(DateTime(rtc.now().year(),rtc.now().month(), rtc.now().day(), DigitSetValue, rtc.now().minute(), rtc.now().second()));
      }
    }

    //set hours units digit
    // Min1 =0   Min10 =1   Hrs1 =2   Hrs10 =3   Sum =4  Win =5
    if ( NumeralSelected == 2 && RTCsetValue == 0 )
    {
      // DigitalClockSettings();// gets the int value DigitalClockDigit from VR2
      hoursUnits = DigitSetValue;
      digitalWrite (LED, LOW);
      if (SerialEnable == 1)
      {
        Serial.print("hoursUnits ");
        Serial.println(hoursUnits);
      }
      hoursRTC = (hoursTens * 10) + hoursUnits;



      rtc.adjust(DateTime(rtc.now().year(), rtc.now().month(), rtc.now().day(), hoursRTC, rtc.now().minute(), rtc.now().second()));
      // stops the numeral steppers rotating after setting new position
      minutes2 = floor(get_min() / 10); //gets 2nd seconds char from seconds for 7 segment display
      minutes1 = get_min() - (minutes2 * 10); //gets 1st seconds char from seconds for 7 segment display

      hours2 = floor(get_hour() / 10); //gets 2nd seconds char from hours for 7 segment display
      hours1 = get_hour() - (hours2 * 10); //gets 1st seconds char from hours for 7 segment display


      minutes1Previous = minutes1;

      minutes2Previous = minutes2;

      hours1Previous = hours1;

      hours2Previous = hours2;

    }


    //set mins tens digit
    // Min1 =0   Min10 =1   Hrs1 =2   Hrs10 =3   Sum =4  Win =5
    if ( NumeralSelected == 1 && RTCsetValue == 0 )
    {

      if ( DigitSetValue < 6) //if greater than 5 not valind for hours tens digit
      {
        // gets the int value DigitalClockDigit from VR2
        minsTens = DigitSetValue;
        digitalWrite (LED, LOW);
        if (SerialEnable == 1)
        {
          Serial.print("minsTens ");
          Serial.println(minsTens);
        }


        //  rtc.adjust(DateTime(rtc.now().year(),rtc.now().month(), rtc.now().day(), rtc.now().hour(), DigitalClockDigit, rtc.now().second()));
      }

    }

    //set mins units digit
    // Min1 =0   Min10 =1   Hrs1 =2   Hrs10 =3   Sum =4  Win =5
    if ( NumeralSelected == 0 && RTCsetValue == 0 )
    {


      // DigitalClockSettings();// gets the int value DigitalClockDigit from VR2
      minsUnits = DigitSetValue;
      digitalWrite (LED, LOW);
      if (SerialEnable == 1)
      {
        Serial.print("minsUnits ");
        Serial.println(minsUnits);
      }

      minsRTC = (minsTens * 10) + minsUnits;
      rtc.adjust(DateTime(rtc.now().year(), rtc.now().month(), rtc.now().day(), rtc.now().hour(), minsRTC, 0));
      // stops the numeral steppers rotating after setting new position
      minutes2 = floor(get_min() / 10); //gets 2nd seconds char from seconds for 7 segment display
      minutes1 = get_min() - (minutes2 * 10); //gets 1st seconds char from seconds for 7 segment display

      hours2 = floor(get_hour() / 10); //gets 2nd seconds char from hours for 7 segment display
      hours1 = get_hour() - (hours2 * 10); //gets 1st seconds char from hours for 7 segment display


      minutes1Previous = minutes1;

      minutes2Previous = minutes2;

      hours1Previous = hours1;

      hours2Previous = hours2;

    }


    //set Summertime
    // Min1 =0   Min10 =1   Hrs1 =2   Hrs10 =3   Sum =4  Win =5
    if ( NumeralSelected == 4 && RTCsetValue == 0 )
    {

      unsigned n = rtc.now().hour();
      unsigned x = n;  // time before clocks went forward
      // Serial.print("Summertime Selected ");
      // Serial.print("Hours was ");
      // Serial.println(x);

      if ( n == 23)
      {
        n = 0;
      }

      else
      {
        n = n + 1;
      }


      // Serial.print("Hours now ");
      // Serial.println(n);



      rtc.adjust(DateTime(rtc.now().year(), rtc.now().month(), rtc.now().day(), n, rtc.now().minute(), rtc.now().second()));

      //####################################

      if ( x == 0 || x == 1 || x == 2  || x == 3 || x == 4 || x == 5 || x == 6 || x == 7 ||  x == 8 || x == 10 || x == 11 || x == 12 || x == 13 || x == 14 || x == 15 || x == 16 || x == 17 || x == 18 || x == 20 || x == 21 || x == 22)
      {
        //turn hours10 0 times



        //turn hours1 1 times
        winterRotations = 0;
        while (winterRotations < 1 )

        {
          winterRotations++;
          //Serial.print("motorRotations ");
          //Serial.print(motorRotations);
          //Serial.println(" ");

          //turn hour 1 motor
          RotateHrsOne();
          /*
            //turn hour 1 motor
            stepperHoursUnits.enableOutputs();
            // Set the current position to 0:
            stepperHoursUnits.setCurrentPosition(0);

            // Run the motor backwars at 1000 steps/second until the motor reaches -3036 steps (3/4 revolution):
            //Serial.println("forward 2542 ");
            while (stepperHoursUnits.currentPosition() != -3096) {  //3036
              stepperHoursUnits.setSpeed(-500);
              stepperHoursUnits.runSpeed();


            }


            // Reset the position to 0:
             //Serial.println("position reset to 0");
            stepperHoursUnits.setCurrentPosition(0);

            // Run the motor forwards at 1000 steps/second until the motor reaches 1012 steps (1/2 revolution from start):
            // Serial.println("backward 494 steps");
            while (stepperHoursUnits.currentPosition() != 1048) { //988
              stepperHoursUnits.setSpeed(500);
              stepperHoursUnits.runSpeed();
            }

            stepperHoursUnits.disableOutputs();
          */
          delay(200);
        }

      }

      //####################################

      if (x == 9 || x == 19 )
      {
        //turn hours10 1 times (2 extra if 20 hrs)
        BlankRotateSum = 1;//allows rotations of blanks if 20hrs
        winterRotations = 0;
        while (winterRotations < 1 )
        {
          winterRotations++;
          // Serial.print("winterRotations ");
          //Serial.print(winterRotations);
          //Serial.println(" ");

          //Serial.print("motorRotations ");
          // Serial.println(motorRotations);

          //turn hour 10 motor
          RotateHrsTen();
          if (x == 19 && BlankRotateSum == 1)// rotate 2 blanks if 20hrs
          {
            RotateHrsTen();
            RotateHrsTen();
            BlankRotateSum = 0;
          }



          delay(200);

        }

        //turn hours1 1 times
        winterRotations = 0;
        while (winterRotations < 1 )

        {
          winterRotations++;
          //Serial.print("motorRotations ");
          //Serial.print(motorRotations);
          //Serial.println(" ");

          //Serial.print("motorRotations ");
          //Serial.println(motorRotations);

          //turn hour 1 motor
          RotateHrsOne();


          delay(200);
        }

      }




      //####################################

      //####################################

      if (x == 23 )
      {
        //turn hours10 1 times
        winterRotations = 0;
        while (winterRotations < 1 )
        {
          winterRotations++;
          //Serial.print("winterRotations ");
          //Serial.print(winterRotations);
          //Serial.println(" ");

          //Serial.print("motorRotations ");
          //Serial.println(motorRotations);

          //turn hour 10 motor
          RotateHrsTen();


          delay(200);

        }

        //turn hours1 7 times
        winterRotations = 0;
        while (winterRotations < 7 )

        {
          winterRotations++;
          //Serial.print("motorRotations ");
          //Serial.print(motorRotations);
          //Serial.println(" ");

          //Serial.print("motorRotations ");
          //Serial.println(motorRotations);

          //turn hour 1 motor
          RotateHrsOne();


          delay(200);
        }

      }




      //####################################



      // stops the numeral steppers rotating after setting new position
      minutes2 = floor(get_min() / 10); //gets 2nd seconds char from seconds for 7 segment display
      minutes1 = get_min() - (minutes2 * 10); //gets 1st seconds char from seconds for 7 segment display

      hours2 = floor(get_hour() / 10); //gets 2nd seconds char from hours for 7 segment display
      hours1 = get_hour() - (hours2 * 10); //gets 1st seconds char from hours for 7 segment display


      minutes1Previous = minutes1;

      minutes2Previous = minutes2;

      hours1Previous = hours1;

      hours2Previous = hours2;


    }


    //set Wintertime
    // Min1 =0   Min10 =1   Hrs1 =2   Hrs10 =3   Sum =4  Win =5
    if ( NumeralSelected == 5 && RTCsetValue == 0 )
    {
      unsigned n = rtc.now().hour(); // time after clocks went back
      unsigned x = n;  // time before clocks went back
      //Serial.print("Wintertime Selected ");
      //Serial.print("Hours was ");
      //Serial.println(x);

      if ( n == 0)
      {
        n = 23;
      }

      else
      {
        n = n - 1;
      }


      //Serial.print("Hours now ");
      //Serial.println(n);



      rtc.adjust(DateTime(rtc.now().year(), rtc.now().month(), rtc.now().day(), n, rtc.now().minute(), rtc.now().second()));
      if (x == 0)
      {
        //turn hours10 2 times
        winterRotations = 0;
        while (winterRotations < 2 )
        {
          winterRotations++;
          //Serial.print("winterRotations ");
          //Serial.print(winterRotations);
          //Serial.println(" ");


          //turn hour 10 motor
          RotateHrsTen();



          delay(200);




        }

        //turn hours1 3 times
        winterRotations = 0;
        while (winterRotations < 3 )

        {
          winterRotations++;
          //Serial.print("motorRotations ");
          //Serial.print(motorRotations);
          //Serial.println(" ");

          //turn hour 1 motor
          RotateHrsOne();



          delay(200);
        }

      }

      //####################################

      if (x == 10 || x == 20 )
      {
        //turn hours10 2 times
        winterRotations = 0;
        while (winterRotations < 2 )
        {
          winterRotations++;
          //Serial.print("winterRotations ");
          //Serial.print(winterRotations);
          //Serial.println(" ");


          //turn hour 10 motor
          RotateHrsTen();




          delay(200);


        }

        //turn hours1 9 times
        winterRotations = 0;
        while (winterRotations < 9 )

        {
          winterRotations++;
          //Serial.print("motorRotations ");
          //Serial.print(motorRotations);
          //Serial.println(" ");

          //turn hour 1 motor
          RotateHrsOne();


          delay(200);
        }

      }




      //####################################









      //####################################
      //if ((x == 1 && n == 0) ||  (x == 2 && n == 1) || (x == 3 && n == 2) || (x == 4 && n == 3) || (x == 5 && n == 4) || (x == 6 && n == 5) || (x == 7 && n == 6) || (x == 8 && n == 7) || (x == 8 && n == 7) || (x == 9 && n == 8)  )
      if (x == 1 || x == 2  || x == 3 || x == 4 || x == 5 || x == 6 || x == 7 || x == 8 || x == 8 || x == 9 || x == 11 || x == 12 || x == 13 || x == 14 || x == 15 || x == 16 || x == 17 || x == 18 || x == 19 || x == 21 || x == 22 || x == 23)
      {
        //turn hours10 0 times



        //turn hours1 9 times
        winterRotations = 0;
        while (winterRotations < 9 )

        {
          winterRotations++;
          //Serial.print("motorRotations ");
          //Serial.print(motorRotations);
          //Serial.println(" ");

          //turn hour 1 motor
          RotateHrsOne();



          delay(200);
        }

      }

      // stops the numeral steppers rotating after setting new position
      minutes2 = floor(get_min() / 10); //gets 2nd seconds char from seconds for 7 segment display
      minutes1 = get_min() - (minutes2 * 10); //gets 1st seconds char from seconds for 7 segment display

      hours2 = floor(get_hour() / 10); //gets 2nd seconds char from hours for 7 segment display
      hours1 = get_hour() - (hours2 * 10); //gets 1st seconds char from hours for 7 segment display


      minutes1Previous = minutes1;

      minutes2Previous = minutes2;

      hours1Previous = hours1;

      hours2Previous = hours2;

    }







    //#########################################################################################
    // Setting of stepper motor numerals





    //####################################################################################################################################################################
    // Set stepper numerals- set pot to digit and press relevant button to set that digit- hour1= hour tens, hour2= hour units,minute1= minute tens & minute2= minute units

    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


    // Min1 =0   Min10 =1   Hrs1 =2   Hrs10 =3   Sum =4  Win =5
    DispSetValue = digitalRead(DispSet);
    //Serial.print("digitalRead(DispSet)= ");
    //Serial.println(DispSetValue);
    if ( DispSetValue == 0 )
    {
      //================================================================================================================

      //Adjust stepper motor Numerals

      motorRotations = DigitSetValue;
      DispSetValue = digitalRead(DispSet);


      //turn hour10 stepper motor

      while (motorRotations > 0 && NumeralSelected == 3 )
      {
        --motorRotations;
        //Serial.print("motorRotations ");
        //Serial.print(motorRotations);
        //Serial.println(" ");

        //turn hour 10 motor
        RotateHrsTen();



        delay(200);
      }


      //turn hour1 stepper motor

      while (motorRotations > 0 && NumeralSelected == 2 )
      {
        --motorRotations;
        //Serial.print("motorRotations ");
        //Serial.print(motorRotations);
        //Serial.println(" ");

        //turn hour 1 motor
        RotateHrsOne();



        delay(200);
      }



      //turn Min10 stepper motor

      while (motorRotations > 0 && NumeralSelected == 1 )
      {
        --motorRotations;
        //Serial.print("motorRotations ");
        //Serial.print(motorRotations);
        //Serial.println(" ");

        //turn Min10 1 motor
        RotateMinTen();



        delay(200);

      }







      //turn min1 stepper motor

      while (motorRotations > 0 && NumeralSelected == 0 )
      {
        --motorRotations;
        //Serial.print("motorRotations ");
        //Serial.print(motorRotations);
        //Serial.println(" ");

        //turn min1 stepper motor
        RotateMinOne();



        delay(200);

      }

      //End Check every minute


      // stops the numeral steppers rotating after setting new position
      minutes2 = floor(get_min() / 10); //gets 2nd seconds char from seconds for 7 segment display
      minutes1 = get_min() - (minutes2 * 10); //gets 1st seconds char from seconds for 7 segment display

      hours2 = floor(get_hour() / 10); //gets 2nd seconds char from hours for 7 segment display
      hours1 = get_hour() - (hours2 * 10); //gets 1st seconds char from hours for 7 segment display


      minutes1Previous = minutes1;

      minutes2Previous = minutes2;

      hours1Previous = hours1;

      hours2Previous = hours2;




    }

    //================================================================================================================



    //End setting of stepper motor numerals
    //#########################################################################################

    // Brett amalagamated 1 sec loop
    // Brett do every second




    secondsOld = secondsNow ;





  }
  //End check every second


  //Brett ################################################################################################
  //Check every minute
  // Do on startup only
  if (initialminutes1 == 1)
  {
    minutes1Previous = minutes1;
    minutes2Previous = minutes2;
    hours1Previous = hours1;
    hours2Previous = hours2;
    initialminutes1 = 0;
  }

  if (minutes1 != minutes1Previous && NumeralSelected == 9 ) //NumeralSelected ==9 only allows the numeral to rotate when the Select switch is fully anti clockwise
  {

    //Serial.print("Minutes1 Units ");
    //Serial.println(minutes1);
    minutes1Previous = minutes1;
    RotateMinOne();
    BlankRotateMin10 = 1;  //enables rotation of blanks on 20 and 50mins

  }

  //End Check every minute

  //Brett #####################################################################
  //Brett #####################################################################
  //Brett #####################################################################
  //Brett #####################################################################

  //Check every 10 minutes



  if (minutes2 != minutes2Previous && NumeralSelected == 9 ) //NumeralSelected ==9 only allows the numeral to rotate when the Select switch is fully anti clockwise
  {

    //Serial.print("Minutes2 Tens ");
    //Serial.println(minutes2);
    minutes2Previous = minutes2;


    //turn Min10 stepper motor

    RotateMinTen();

    if (minutes2 == 2 || minutes2 == 5 && BlankRotateMin10 == 1) // if mins10 are 2 or 5 rotate extra mis 10 2 more times to clear blanks
    {
      RotateMinTen();
      RotateMinTen();
      BlankRotateMin10 = 0;
    }


  }




  //End Check every 10 minutes



  //Brett #####################################################################
  //Check every hour


  if (hours1 != hours1Previous && NumeralSelected == 9 ) //NumeralSelected ==9 only allows the numeral to rotate when the Select switch is fully anti clockwise
  {

    //Serial.print("Hours1 Units ");
    //Serial.println(hours1);
    hours1Previous = hours1;

    RotateHrsOne();


    BlankRotateHrs10 = 1;// enable blanks to be rotated at 20 hrs
  }
  //End Check every hour



  //#######################################################################

  //Midnight check

  if (hours1 == 1)// resets midnight check
  {
    midnightcheck = 0;
  }

  //Check if hours2 is  and hours1 is 0 then rotate 6 more times to 0.

  if ( hours2 == 0 && hours1 == 0 && midnightcheck == 0 && NumeralSelected == 9 ) //NumeralSelected ==9 only allows the numeral to rotate when the Select switch is fully anti clockwise
  {
    midnight = 6;

    //turns hour1 6 rotations
    while (midnight > 0)
    {
      --midnight;
      //turn hour 1 motor
      RotateHrsOne();



      delay(200);
    }
    midnightcheck = 1;//stops turning until reset at after an hour

  }



  //Brett #####################################################################
  //Check every 10 hour


  if (hours2 != hours2Previous && NumeralSelected == 9 ) //NumeralSelected ==9 only allows the numeral to rotate when the Select switch is fully anti clockwise
  {

    //Serial.print("Hours2 Tens ");
    //Serial.println(hours2);
    hours2Previous = hours2;

    RotateHrsTen();
    if (hours2 == 2 && BlankRotateHrs10 == 1) // if hours 10 is 2 rotates hrs ten 2 more times to clear blanks.
    {
      RotateHrsTen();
      RotateHrsTen();
      BlankRotateHrs10 = 0;
    }

  }



  //End Check every 10 hour










}  // end main loop


String getDayOfWeek(int i)
{
  switch (i)
  {
    case 0: return "Monday"; break;
    case 1: return "Tuesday"; break;
    case 2: return "Wednesday"; break;
    case 3: return "Thursday"; break;
    case 4: return "Friday"; break;
    case 5: return "Saturday"; break;
    case 6: return "Sunday"; break;
    default: return "Monday"; break;
  }
}


//Numeral rotation
// Note all numeral rotate backwards but as 1s & 10s numeral motors are fitted on oppersite side, rotation is revearsed to each other
//================================================================================================================
void RotateHrsTen()
{

  //turn hour 10 motor
  stepperHoursTens.enableOutputs();
  // Set the current position to 0:
  stepperHoursTens.setCurrentPosition(0);

  // Run the motor forwards at "setspeed" steps/second until the motor reaches "currentPosition"
  while (stepperHoursTens.currentPosition() != 2986) {  //3036
    stepperHoursTens.setSpeed(400);
    stepperHoursTens.runSpeed();


  }


  // Reset the position to 0:
  stepperHoursTens.setCurrentPosition(0);
  delay(200);

  // Run the motor backwards at "setspeed" steps/second until the motor reaches "currentPosition"
  while (stepperHoursTens.currentPosition() != -938) { //988
    stepperHoursTens.setSpeed(-500);
    stepperHoursTens.runSpeed();
  }

  stepperHoursTens.disableOutputs();
  delay(200);
}

//End turn hour 10 motor




//----------------------------------------------------------------------------------------------------------------
void RotateHrsOne()
{
  //turn hour 1 motor
  stepperHoursUnits.enableOutputs();
  // Set the current position to 0:
  stepperHoursUnits.setCurrentPosition(0);

  // Run the motor backwards at "setspeed" steps/second until the motor reaches "currentPosition"
  while (stepperHoursUnits.currentPosition() != -2786) {  //3036
    stepperHoursUnits.setSpeed(-500);
    stepperHoursUnits.runSpeed();


  }


  // Reset the position to 0:
  stepperHoursUnits.setCurrentPosition(0);
  delay(200);
  // Run the motor forwards at "setspeed" steps/second until the motor reaches "currentPosition"
  while (stepperHoursUnits.currentPosition() != 738) { //988
    stepperHoursUnits.setSpeed(500);
    stepperHoursUnits.runSpeed();
  }

  stepperHoursUnits.disableOutputs();

  delay(200);
}
//End turn hour 1 motor

//----------------------------------------------------------------------------------------------------------------




//----------------------------------------------------------------------------------------------------------------
void RotateMinTen()
{
  //turn Min10  motor
  stepperMinsTens.enableOutputs();
  // Set the current position to 0:
  stepperMinsTens.setCurrentPosition(0);

  // Run the motor forwards at "setspeed" steps/second until the motor reaches "currentPosition"
  while (stepperMinsTens.currentPosition() != 2986) {  //2936
    stepperMinsTens.setSpeed(400);
    stepperMinsTens.runSpeed();


  }


  // Reset the position to 0:
  //Serial.println("position reset to 0");
  stepperMinsTens.setCurrentPosition(0);
  delay(200);

  // Run the motor backwards at "setspeed" steps/second until the motor reaches "currentPosition"
  while (stepperMinsTens.currentPosition() != -938) { //888
    stepperMinsTens.setSpeed(-400);
    stepperMinsTens.runSpeed();
  }

  stepperMinsTens.disableOutputs();
  delay(200);
}




//End turn Min10  motor

//----------------------------------------------------------------------------------------------------------------




//----------------------------------------------------------------------------------------------------------------
//Mins1
void RotateMinOne()
{
  //turn min 1 motor
  stepperMinsUnits.enableOutputs();
  // Set the current position to 0:
  stepperMinsUnits.setCurrentPosition(0);

  // Run the motor backwards at "setspeed" steps/second until the motor reaches "currentPosition"
  while (stepperMinsUnits.currentPosition() != -2786) {  //3036
    stepperMinsUnits.setSpeed(-400);
    stepperMinsUnits.runSpeed();


  }


  // Reset the position to 0:
  //Serial.println("position reset to 0");
  stepperMinsUnits.setCurrentPosition(0);
  delay(200);
  // Run the motor forwards at "setspeed" steps/second until the motor reaches "currentPosition"

  while (stepperMinsUnits.currentPosition() != 738) { //988
    stepperMinsUnits.setSpeed(400);
    stepperMinsUnits.runSpeed();
  }

  stepperMinsUnits.disableOutputs();

  delay(200);
  //end turn min1 motor
}


//----------------------------------------------------------------------------------------------------------------




//================================================================================================================






//Clock Setting
//================================================================================================================
//gets numeral selection from pot
void NumeralSelectFunction()
{

  //Print sensor value every second
  NumeralSelect = analogRead(NumeralSelectPin);    // read the value from the pot
  //Serial.print ("NumeralSelect Value ");
  //Serial.println (NumeralSelect);
  //------------------------------------------------


  // Set values for NumeralSelect Pot

  //Off 9 normal clock running position

  if (NumeralSelect >= 0 && NumeralSelect < 250)
  {
    NumeralSelected = 9; // Normal running selected

  }




  //0
  if (NumeralSelect >= 250 && NumeralSelect < 945)
  {
    NumeralSelected = 0; // Min1 selected

  }


  //1
  else if (NumeralSelect >= 945 && NumeralSelect < 1700)
  {
    NumeralSelected = 1; // Min10 selected


  }

  //2
  else if (NumeralSelect >= 1700 && NumeralSelect < 2455)
  {
    NumeralSelected = 2; // Hrs1 selected

  }

  //3
  else if (NumeralSelect >= 2455 && NumeralSelect < 3315)
  {
    NumeralSelected = 3; // Hrs10 selected


  }

  //4
  else if (NumeralSelect >= 3315 && NumeralSelect < 4050)
  {
    NumeralSelected = 4; // Summer Selected


  }

  //5
  else if (NumeralSelect >= 4050 && NumeralSelect < 4096)
  {
    NumeralSelected = 5; // Winter Selected

  }


}

//================================================================================================================


//================================================================================================================
//gets numeral selection from pot
void DigitSetFunction()
{

  //Print sensor value every second
  DigitSet = analogRead(DigitSetPin);    // read the value from the pot
  //Serial.print ("NumeralSelect Value ");
  //Serial.println (NumeralSelect);
  //------------------------------------------------


  // Set values for DigitSet Pot
  //0
  if (DigitSet >= 0 && DigitSet < 45)
  {
    DigitSetValue = 0; // 0 selected

  }
  //1
  else if (DigitSet >= 45 && DigitSet < 448)
  {
    DigitSetValue = 1; // 1 selected


  }

  //2
  else if (DigitSet >= 448 && DigitSet < 810)
  {
    DigitSetValue = 2; // 2 selected

  }

  //3
  else if (DigitSet >= 810 && DigitSet < 1315)
  {
    DigitSetValue = 3; // 3 selected


  }

  //4
  else if (DigitSet >= 1315 && DigitSet < 1776)
  {
    DigitSetValue = 4; // 4 Selected


  }

  //5
  else if (DigitSet >= 1776 && DigitSet < 2250)
  {
    DigitSetValue = 5; // 5 Selected

  }


  //6
  else if (DigitSet >= 2250 && DigitSet < 2700)
  {
    DigitSetValue = 6; // 6 selected

  }


  //7
  else if (DigitSet >= 2700 && DigitSet < 3160)
  {
    DigitSetValue = 7; // 7 selected


  }

  //8
  else if (DigitSet >= 3160 && DigitSet < 3722)
  {
    DigitSetValue = 8; // 8 selected

  }

  //9
  else if (DigitSet >= 3722 && DigitSet < 4096)
  {
    DigitSetValue = 9; // 9 selected

  }






}










//Returns integer value of the second.
int get_sec(void) {
  int s;
  s = (int)rtc.now().second();
  return s;
}

//Returns integer value of the minute.
int get_min(void) {
  int m;
  m = (int)rtc.now().minute();
  return m;
}

//Returns integer value of the hour.
int get_hour(void) {
  int h;
  h = (int)rtc.now().hour();
  return h;
}

//Returns integer value of the day.
int get_day(void) {
  int dd;
  dd = (int)rtc.now().day();
  return dd;
}

//Returns integer value of the month.
int get_month(void) {
  int mth;
  mth = (int)rtc.now().month();
  return mth;
}

//Returns integer value of the year.
int get_year(void) {
  int yy;
  yy = (int)rtc.now().year();
  return yy;
}







//================================================================================================================
//
